# Short Text Categorization in Python

This repository is a collection of algorithms for multi-class classification to short texts using Python. This package is still *under development*. Modules are backward compatible unless otherwise specified. Feel free to give suggestions.

To install it, in a console, use `pip`.

```
>>> pip install shorttext
```

The Word2Vec model is implemented with [`gensim`](https://radimrehurek.com/gensim/), and various neural networks with [`keras`](https://keras.io/), with a [`Theano`](http://deeplearning.net/software/theano/) backend. Certain natural language processing tasks are implemented with [`spacy`](https://spacy.io/) and [`gensim`](https://radimrehurek.com/gensim/). This also imports [`numpy`](http://www.numpy.org/), [`scipy`](https://www.scipy.org/), and [`pandas`](http://pandas.pydata.org/).
 
Upcoming changes [here](UPCOMING.md).

# News

* 12/21/2016: `shorttext` 0.2.0 released.
* 11/25/2016: `shorttext` 0.1.2 released.
* 11/21/2016: `shorttext` 0.1.1 released.

# Useful Links

* Documentation : [https://pythonhosted.org/shorttext/](https://pythonhosted.org/shorttext/)
* Github: [https://github.com/stephenhky/PyShortTextCategorization](https://github.com/stephenhky/PyShortTextCategorization)
* PyPI: [https://pypi.python.org/pypi/shorttext](https://pypi.python.org/pypi/shorttext)
* "Python Package for Short Text Mining", [WordPress](https://datawarrior.wordpress.com/2016/12/22/python-package-for-short-text-mining/)
* An [earlier version](https://github.com/stephenhky/PyShortTextCategorization/tree/b298d3ce7d06a9b4e0f7d32f27bab66064ba7afa) of this repository is a demonstration of the following blog post: [Short Text Categorization using Deep Neural Networks and Word-Embedding Models](https://datawarrior.wordpress.com/2016/10/12/short-text-categorization-using-deep-neural-networks-and-word-embedding-models/)

